Index: lang/en_utf8/blog.php
=========================================================
--- lang/en_utf8/blog.php	(revision 1.31)
+++ lang/en_utf8/blog.php	Wed Oct 28 15:59:14 WST 2009
@@ -3,10 +3,15 @@
 
 
 $string['addnewentry'] = 'Add a new entry';
-$string['addnewexternalblog'] = 'New external blog...';
+$string['addnewexternalblog'] = 'Register an external blog...';
 $string['assocdescription'] = 'If you are writing about a course and/or activity modules, select them here.';
+$string['associatewithcourse'] = 'Blog about course $a->coursename';
+$string['associatewithmodule'] = 'Blog about $a->modtype: $a->modname';
+$string['associated'] = 'Associated $a';
+$string['association'] = 'Association';
 $string['associations'] = 'Associations';
 $string['associationunviewable'] = 'This entry cannot be viewed by others until a course is associated with it or the \'Publish To\' field is changed';
+$string['autotags'] = 'Tags associated with each imported blog entry';
 $string['backupblogshelp'] = 'If enabled then blogs will be included in SITE automated backups';
 $string['blockexternalstitle'] = 'External Blogs';
 $string['blockmenutitle'] = 'Blog Menu';
@@ -14,6 +19,7 @@
 $string['blocktagstitle'] = 'Blog Tags';
 $string['blocktitle'] = 'Blog tags block title';
 $string['blog'] = 'Blog';
+$string['blogaboutthis'] = 'Blog about this $a->type';
 $string['blogadministration'] = 'Blog administration';
 $string['blogdeleteconfirm'] = 'Delete this blog?';
 $string['blogdisable'] = 'Blogging is disabled!';
@@ -32,20 +38,21 @@
 $string['cannotviewsiteblog'] = 'You do not have the required permissions to view all site blogs';
 $string['cannotviewuserblog'] = 'You do not have the required permissions to read user blogs';
 $string['configexternalblogcrontime'] = 'How often Moodle checks the external blogs for new entries.';
-$string['configuseexternalblogs'] = 'Enables users to add links to external blogs. Moodle regularly checks if these blogs, then copies new entries to the blog of the Moodle user.';
 $string['configmaxexternalblogsperuser'] = 'The number of external blogs each user is allowed to link to their Moodle blog.';
 $string['configuseblogassociations'] = 'Enables the association of blog entries with courses and course modules.';
+$string['configuseexternalblogs'] = 'Enables users to add links to external blogs. Moodle regularly checks if these blogs, then copies new entries to the blog of the Moodle user.';
 $string['courseblog'] = 'Course blog: $a';
 $string['courseblogdisable'] = 'Course blogs is not enabled';
 $string['courseblogs'] = 'Users can only see blogs for people who share a course';
+$string['deleteblogassociations'] = 'Delete blog associations';
 $string['deleteotagswarn'] = 'Are you sure you want to remove this / these tags <br />from all blog posts and remove it from the system?';
 $string['disableblogs'] = 'Disable blog system completely';
 $string['donothaveblog'] = 'You do not have your own blog, sorry.';
 $string['editentry'] = 'Edit a blog entry';
-$string['editexternalblog'] = 'Edit an external blog';
+$string['editexternalblog'] = 'Edit this external blog';
 $string['emptybody'] = 'Blog entry body can not be empty';
+$string['emptyrssfeed'] = 'The URL you entered does not point to a valid RSS feed';
 $string['emptytitle'] = 'Blog entry title can not be empty';
-$string['emptyrssfeed'] = 'The URL you entered does not point to a valid RSS feed';
 $string['entrybody'] = 'Blog entry body';
 $string['entrybodyonlydesc'] = 'Entry description';
 $string['entryerrornotyours'] = 'This entry is not yours';
@@ -54,7 +61,11 @@
 $string['entryupdated'] = 'Blog entry updated';
 $string['externalblogcrontime'] = 'External blog cron schedule';
 $string['externalblogs'] = 'External blogs';
+$string['externalblogdeleted'] = 'External blog deleted';
+$string['feedisinvalid'] = 'This feed is invalid';
+$string['feedisvalid'] = 'This feed is valid';
 $string['filterblogsby'] = 'Filter entries by...';
+$string['filtertags'] = 'External tags';
 $string['groupblog'] = 'Group blog: $a';
 $string['groupblogdisable'] = 'Group blog is not enabled';
 $string['groupblogentries'] = 'Blog entries associated with $a->coursename by group $a->groupname';
@@ -65,9 +76,11 @@
 $string['invalidurl'] = 'This URL is unreachable';
 $string['linktooriginalentry'] = 'Link to original blog entry';
 $string['maxexternalblogsperuser'] = 'Maximum number of external blogs per user';
+$string['modulename'] = 'Blog';
 $string['mustassociatecourse'] = 'If you are publishing to course or group members, you must associate a course with this entry';
 $string['noentriesyet'] = 'No visible entries here';
 $string['noguestpost'] = 'Guest can not post blogs!';
+$string['nopermissionstodeleteentry'] = 'You lack the permissions required to delete this blog entry';
 $string['norighttodeletetag'] = 'You have no rights to delete this tag - $a';
 $string['nosuchentry'] = 'No such blog entry';
 $string['notallowedtoedit'] = 'You are not allowed to edit this entry';
@@ -88,8 +101,10 @@
 $string['publishtosite'] = 'Anyone on this site';
 $string['publishtoworld'] = 'Anyone in the world';
 $string['readfirst'] = 'Read this first';
+$string['relatedblogentries'] = 'Related blog entries';
+$string['retrievedfrom'] = 'Retrieved from ';
+$string['searchterm'] = 'Search: $a';
 $string['settingsupdatederror'] = 'An error has occurred, blog preference setting could not be updated';
-$string['searchterm'] = 'Search: $a';
 $string['siteblog'] = 'Site blog: $a';
 $string['siteblogdisable'] = 'Site blog is not enabled';
 $string['siteblogs'] = 'All site users can see all blog entries';
@@ -98,14 +113,17 @@
 $string['tags'] = 'Tags';
 $string['tagsort'] = 'Sort the tag display by';
 $string['tagtext'] = 'Tag text';
+$string['timefetched'] = 'Time of last sync';
 $string['timewithin'] = 'Display tags used within this many days';
 $string['updateentrywithid'] = 'Updating entry';
-$string['userblog'] = 'User blog: $a';
 $string['useblogassociations'] = 'Enable blog associations';
 $string['useexternalblogs'] = 'Enable external blogs';
+$string['userblog'] = 'User blog: $a';
 $string['userblogentries'] = 'Blog entries by $a';
+$string['valid'] = 'Valid';
 $string['viewallblogentries'] = 'All entries about this $a';
-$string['viewblogentries'] = 'Entries about this $a';
+$string['viewallmodentries'] = 'All entries about this $a->type';
+$string['viewblogentries'] = 'Entries about this $a->type';
 $string['viewblogsfor'] = 'View all entries for...';
 $string['viewcourseblogs'] = 'View entries for course...';
 $string['viewgroupblogs'] = 'View entries for group...';
Index: lang/en_utf8/forum.php
=========================================================
--- lang/en_utf8/forum.php	(revision 1.61)
+++ lang/en_utf8/forum.php	Thu Oct 15 09:39:03 WST 2009
@@ -30,6 +30,7 @@
 $string['blockafter'] = 'Post threshold for blocking';
 $string['blockperiod'] = 'Time period for blocking';
 $string['blockperioddisabled'] = 'Don\'t block';
+$string['blogforum'] = 'Standard forum displayed in a blog-like format';
 $string['bynameondate'] = 'by $a->name - $a->date';
 $string['cannotadd'] = 'Could not add the discussion for this forum';
 $string['cannotaddteacherforumto'] = 'Could not add converted teacher forum instance to section 0 in the course';
@@ -164,6 +165,7 @@
 $string['generalforum'] = 'Standard forum for general use';
 $string['generalforums'] = 'General forums';
 $string['inforum'] = 'in $a';
+$string['introblog'] = 'The posts in this forum were copied here automatically from blogs of users in this course because those blog entries are no longer available';
 $string['intronews'] = 'General news and announcements';
 $string['introsocial'] = 'An open forum for chatting about anything you want to';
 $string['introteacher'] = 'A forum for teacher-only notes and discussion';
Index: lib/db/access.php
=========================================================
--- lib/db/access.php	(revision 1.108)
+++ lib/db/access.php	Thu Oct 15 09:39:03 WST 2009
@@ -798,7 +798,22 @@
     'moodle/blog:view' => array(
 
         'captype' => 'read',
-        'contextlevel' => CONTEXT_COURSE,
+        'contextlevel' => CONTEXT_SYSTEM,
+        'legacy' => array(
+            'guest' => CAP_ALLOW,
+            'user' => CAP_ALLOW,
+            'student' => CAP_ALLOW,
+            'teacher' => CAP_ALLOW,
+            'editingteacher' => CAP_ALLOW,
+            'admin' => CAP_ALLOW
+        )
+    ),
+
+    'moodle/blog:search' => array(
+
+        'riskbitmask' => RISK_PERSONAL,
+        'captype' => 'read',
+        'contextlevel' => CONTEXT_SYSTEM,
         'legacy' => array(
             'guest' => CAP_ALLOW,
             'user' => CAP_ALLOW,
@@ -809,6 +824,16 @@
         )
     ),
 
+    'moodle/blog:viewdrafts' => array(
+
+        'riskbitmask' => RISK_PERSONAL,
+        'captype' => 'read',
+        'contextlevel' => CONTEXT_SYSTEM,
+        'legacy' => array(
+            'admin' => CAP_ALLOW
+        )
+    ),
+
     'moodle/blog:create' => array( // works in CONTEXT_SYSTEM only
 
         'riskbitmask' => RISK_SPAM,
@@ -826,14 +851,14 @@
         'riskbitmask' => RISK_SPAM,
 
         'captype' => 'write',
-        'contextlevel' => CONTEXT_COURSE,
+        'contextlevel' => CONTEXT_SYSTEM,
         'legacy' => array(
             'teacher' => CAP_ALLOW,
             'editingteacher' => CAP_ALLOW,
             'admin' => CAP_ALLOW
         )
     ),
-    
+
     'moodle/blog:manageexternal' => array(
 
         'riskbitmask' => RISK_SPAM,
@@ -849,6 +874,31 @@
         )
     ),
 
+    'moodle/blog:associatecourse' => array(
+
+        'captype' => 'write',
+        'contextlevel' => CONTEXT_COURSE,
+        'legacy' => array(
+            'student' => CAP_ALLOW,
+            'user' => CAP_ALLOW,
+            'teacher' => CAP_ALLOW,
+            'editingteacher' => CAP_ALLOW,
+            'admin' => CAP_ALLOW
+        )
+    ),
+
+    'moodle/blog:associatemodule' => array(
+
+        'captype' => 'write',
+        'contextlevel' => CONTEXT_MODULE,
+        'legacy' => array(
+            'student' => CAP_ALLOW,
+            'user' => CAP_ALLOW,
+            'teacher' => CAP_ALLOW,
+            'editingteacher' => CAP_ALLOW,
+            'admin' => CAP_ALLOW
+        )
+    ),
 
     'moodle/calendar:manageownentries' => array( // works in CONTEXT_SYSTEM only
 
Index: lib/db/upgrade.php
=========================================================
--- lib/db/upgrade.php	(revision 1.339)
+++ lib/db/upgrade.php	Tue Oct 27 13:42:27 WST 2009
@@ -2629,6 +2629,83 @@
         upgrade_main_savepoint($result, 2009102600);
     }
 
+   if ($result && $oldversion < 2009102700) {
+
+    /// Define table blog_association to be created
+        $table = new xmldb_table('blog_association');
+
+    /// Adding fields to table blog_association
+        $table->add_field('id', XMLDB_TYPE_INTEGER, '10', XMLDB_UNSIGNED, XMLDB_NOTNULL, XMLDB_SEQUENCE, null);
+        $table->add_field('contextid', XMLDB_TYPE_INTEGER, '10', XMLDB_UNSIGNED, XMLDB_NOTNULL, null, null);
+        $table->add_field('blogid', XMLDB_TYPE_INTEGER, '10', XMLDB_UNSIGNED, XMLDB_NOTNULL, null, null);
+
+    /// Adding keys to table blog_association
+        $table->add_key('primary', XMLDB_KEY_PRIMARY, array('id'));
+        $table->add_key('contextid', XMLDB_KEY_FOREIGN, array('contextid'), 'context', array('id'));
+        $table->add_key('blogid', XMLDB_KEY_FOREIGN, array('blogid'), 'post', array('id'));
+
+    /// Conditionally launch create table for blog_association
+        if (!$dbman->table_exists($table)) {
+            $dbman->create_table($table);
+        }
+
+/// Define table blog_external to be created
+        $table = new xmldb_table('blog_external');
+
+    /// Adding fields to table blog_external
+        $table->add_field('id', XMLDB_TYPE_INTEGER, '10', XMLDB_UNSIGNED, XMLDB_NOTNULL, XMLDB_SEQUENCE, null);
+        $table->add_field('userid', XMLDB_TYPE_INTEGER, '10', XMLDB_UNSIGNED, XMLDB_NOTNULL, null, null);
+        $table->add_field('name', XMLDB_TYPE_CHAR, '255', null, XMLDB_NOTNULL, null, null);
+        $table->add_field('description', XMLDB_TYPE_TEXT, 'small', null, null, null, null);
+        $table->add_field('url', XMLDB_TYPE_TEXT, 'small', null, XMLDB_NOTNULL, null, null);
+        $table->add_field('filtertags', XMLDB_TYPE_CHAR, '255', null, null, null, null);
+        $table->add_field('failedlastsync', XMLDB_TYPE_INTEGER, '1', XMLDB_UNSIGNED, XMLDB_NOTNULL, null, '0');
+        $table->add_field('timemodified', XMLDB_TYPE_INTEGER, '10', XMLDB_UNSIGNED, null, null, null);
+        $table->add_field('timefetched', XMLDB_TYPE_INTEGER, '10', XMLDB_UNSIGNED, XMLDB_NOTNULL, null, '0');
+
+    /// Adding keys to table blog_external
+        $table->add_key('primary', XMLDB_KEY_PRIMARY, array('id'));
+        $table->add_key('userid', XMLDB_KEY_FOREIGN, array('userid'), 'user', array('id'));
+
+    /// Conditionally launch create table for blog_external
+        if ($dbman->table_exists($table)) {
+            // Delete the existing one first (comes from early dev version)
+            $dbman->drop_table($table);
+        }
+        $dbman->create_table($table);
+
+        // Print notice about need to upgrade bloglevel
+        if (($CFG->bloglevel == BLOG_COURSE_LEVEL || $CFG->bloglevel == BLOG_GROUP_LEVEL) && empty($CFG->bloglevel_upgrade_complete)) {
+            echo $OUTPUT->notification(get_string('bloglevelupgradenotice', 'admin'));
+
+            // email admins about the need to upgrade their system using the admin/bloglevelupgrade.php script
+            $admins = get_admins();
+            $site = get_site();
+
+            $a = new StdClass;
+            $a->sitename = $site->fullname;
+            $a->fixurl   = "$CFG->wwwroot/$CFG->admin/bloglevelupgrade.php";
+
+            $subject   = get_string('bloglevelupgrade', 'admin');
+            $plainbody = get_string('bloglevelupgradebody', 'admin', $a);
+            $htmlbody  = get_string('bloglevelupgradehtml', 'admin', $a);
+
+            foreach ($admins as $admin) {
+                $eventdata = new object();
+                $eventdata->component = 'moodle';
+                $eventdata->userfrom = $USER;
+                $eventdata->userto = $admin;
+                $eventdata->subject = $subject;
+                $eventdata->fullmessage = $plainbody;
+                $eventdata->fullmessageformat = FORMAT_PLAIN;
+                $eventdata->fullmessagehtml = $htmlbody;
+                events_trigger('message_send', $eventdata);
+            }
+        }
+    /// Main savepoint reached
+        upgrade_main_savepoint($result, 2009102700);
+    }
+    
     return $result;
 }
 
Index: lib/db/upgradelib.php
=========================================================
--- lib/db/upgradelib.php	(revision 1.26)
+++ lib/db/upgradelib.php	Thu Oct 15 09:39:03 WST 2009
@@ -204,7 +204,7 @@
             }
 
             if (!$fs->file_exists(SYSCONTEXTID, 'blog', $entry->id, '/', $filename)) {
-                $file_record = array('contextid'=>SYSCONTEXTID, 'filearea'=>'blog', 'itemid'=>$entry->id, 'filepath'=>'/', 'filename'=>$filename,
+                $file_record = array('contextid'=>SYSCONTEXTID, 'filearea'=>'blog_attachment', 'itemid'=>$entry->id, 'filepath'=>'/', 'filename'=>$filename,
                                      'timecreated'=>filectime($pathname), 'timemodified'=>filemtime($pathname), 'userid'=>$entry->userid);
                 $fs->create_file_from_pathname($file_record, $pathname);
             }
Index: lib/moodlelib.php
=========================================================
--- lib/moodlelib.php	(revision 1.1255)
+++ lib/moodlelib.php	Tue Oct 20 14:43:59 WST 2009
@@ -4196,7 +4196,13 @@
         note_delete_all($data->courseid);
         $status[] = array('component'=>$componentstr, 'item'=>get_string('deletenotes', 'notes'), 'error'=>false);
     }
-
+    
+    if (!empty($data->delete_blog_associations)) {
+        require_once($CFG->dirroot.'/blog/lib.php');
+        blog_remove_associations_for_course($data->courseid);
+        $status[] = array('component'=>$componentstr, 'item'=>get_string('deleteblogassociations', 'blog'), 'error'=>false);
+    }
+
     $componentstr = get_string('roles');
 
     if (!empty($data->reset_roles_overrides)) {
Index: lib/navigationlib.php
=========================================================
--- lib/navigationlib.php	(revision 1.41)
+++ lib/navigationlib.php	Thu Oct 29 10:23:48 WST 2009
@@ -1378,7 +1378,8 @@
                         $filterselect = clean_param($filterselect, PARAM_INT);
 
                         if ($CFG->bloglevel >= 3) {
-                            $participants->add(get_string('blogs','blog'), blog_get_blogs_url(array('course'=>$filterselect))->out());
+                            $blogsurls = new moodle_url($CFG->wwwroot.'/blog/index.php', array('courseid' => $filterselect));
+                            $participants->add(get_string('blogs','blog'), $blogsurls->out());
                         }
                         
                         if (!empty($CFG->enablenotes) && (has_capability('moodle/notes:manage', $this->context) || has_capability('moodle/notes:view', $this->context))) {
Index: mod/forum/lib.php
=========================================================
--- mod/forum/lib.php	(revision 1.821)
+++ mod/forum/lib.php	Wed Oct 28 14:26:07 WST 2009
@@ -3054,6 +3054,12 @@
             $forum->assessed = 0;
             $forum->forcesubscribe = 0;
             break;
+        case "blog":
+            $forum->name = get_string('blogforum', 'forum');
+            $forum->intro = get_string('introblog', 'forum');
+            $forum->assessed = 0;
+            $forum->forcesubscribe = 0;
+            break;
         default:
             echo $OUTPUT->notification("That forum type doesn't exist!");
             return false;
@@ -5531,12 +5537,19 @@
         echo "<form id=\"newdiscussionform\" method=\"get\" action=\"$CFG->wwwroot/mod/forum/post.php\">";
         echo '<div>';
         echo "<input type=\"hidden\" name=\"forum\" value=\"$forum->id\" />";
-        echo '<input type="submit" value="';
-        echo ($forum->type == 'news') ? get_string('addanewtopic', 'forum')
-            : (($forum->type == 'qanda')
-               ? get_string('addanewquestion','forum')
-               : get_string('addanewdiscussion', 'forum'));
-        echo '" />';
+        switch ($forum->type) {
+            case 'news':
+            case 'blog':
+                $buttonadd = get_string('addanewtopic', 'forum');
+                break;
+            case 'qanda':
+                $buttonadd = get_string('addanewquestion', 'forum');
+                break;
+            default:
+                $buttonadd = get_string('addanewdiscussion', 'forum');
+                break;
+        }
+        echo '<input type="submit" value="'.$buttonadd.'" />';
         echo '</div>';
         echo '</form>';
         echo "</div>\n";
@@ -7895,7 +7908,7 @@
 }
 
 /**
- * Returns array of forum types
+ * Returns array of forum types chooseable on the forum editing form
  *
  * @return array
  */
@@ -7903,7 +7916,8 @@
     return array ('general'  => get_string('generalforum', 'forum'),
                   'eachuser' => get_string('eachuserforum', 'forum'),
                   'single'   => get_string('singleforum', 'forum'),
-                  'qanda'    => get_string('qandaforum', 'forum'));
+                  'qanda'    => get_string('qandaforum', 'forum'),
+                  'blog'     => get_string('blogforum', 'forum'));
 }
 
 /**
@@ -7917,7 +7931,8 @@
                   'general'  => get_string('generalforum', 'forum'),
                   'eachuser' => get_string('eachuserforum', 'forum'),
                   'single'   => get_string('singleforum', 'forum'),
-                  'qanda'    => get_string('qandaforum', 'forum'));
+                  'qanda'    => get_string('qandaforum', 'forum'),
+                  'blog'     => get_string('blogforum', 'forum'));
 }
 
 /**
Index: mod/forum/view.php
=========================================================
--- mod/forum/view.php	(revision 1.137)
+++ mod/forum/view.php	Thu Oct 15 09:39:03 WST 2009
@@ -179,6 +179,18 @@
             }
             break;
 
+        case 'blog':
+            if (!empty($forum->intro)) {
+                echo $OUTPUT->box(format_module_intro('forum', $forum, $cm->id), 'generalbox', 'intro');
+            }
+            echo '<br />';
+            if (!empty($showall)) {
+                forum_print_latest_discussions($course, $forum, 0, 'plain', '', -1, -1, -1, 0, $cm);
+            } else {
+                forum_print_latest_discussions($course, $forum, -1, 'plain', '', -1, -1, $page, $CFG->forum_manydiscussions, $cm);
+            }
+            break;
+
         default:
             if (!empty($forum->intro)) {
                 echo $OUTPUT->box(format_module_intro('forum', $forum, $cm->id), 'generalbox', 'intro');
Index: pluginfile.php
=========================================================
--- pluginfile.php	(revision 1.16)
+++ pluginfile.php	Thu Oct 15 09:39:03 WST 2009
@@ -57,7 +57,7 @@
 
 
 if ($context->contextlevel == CONTEXT_SYSTEM) {
-    if ($filearea === 'blog') {
+    if ($filearea === 'blog_attachment' || $filearea === 'blog_post') {
 
         if (empty($CFG->bloglevel)) {
             print_error('siteblogdisable', 'blog');
@@ -95,7 +95,7 @@
         //TODO: implement shared course and shared group access
 
         $relativepath = '/'.implode('/', $args);
-        $fullpath = $context->id.'blog'.$entryid.$relativepath;
+        $fullpath = $context->id.$filearea.$entryid.$relativepath;
 
         if (!$file = $fs->get_file_by_hash(sha1($fullpath)) or $file->is_directory()) {
             send_file_not_found();
Index: tag/index.php
=========================================================
--- tag/index.php	(revision 1.46)
+++ tag/index.php	Fri Oct 23 11:09:41 WST 2009
@@ -92,14 +92,15 @@
 }
 
 // Print up to 10 previous blogs entries
+if (has_capability('moodle/blog:view', $systemcontext)) {
+    require_once($CFG->dirroot.'/blog/lib.php');
+    require_once($CFG->dirroot.'/blog/locallib.php');
 
-// I was not able to use get_items_tagged_with() because it automatically
-// tries to join on 'blog' table, since the itemtype is 'blog'. However blogs
-// uses the post table so this would not really work.    - Yu 29/8/07
-if (has_capability('moodle/blog:view', $systemcontext)) {  // You have to see blogs obviously
+    $bloglisting = new blog_listing(array('tag' => $tag->id));
+    $limit = 10;
+    $start = 0;
 
-    $count = 10;
-    if ($blogs = blog_fetch_entries(array('tag'=>$tag->id), $count)) {
+    if ($blogs = $bloglisting->get_entries($start, $limit)) {
 
         echo $OUTPUT->box_start('generalbox', 'tag-blogs');
         $heading = get_string('relatedblogs', 'tag', $tagname). ' ' . get_string('taggedwith', 'tag', $tagname);
@@ -114,7 +115,7 @@
                 $class = '';
             }
             echo '<li '.$class.'>';
-            echo '<a '.$class.' href="'.$CFG->wwwroot.'/blog/index.php?postid='.$blog->id.'">';
+            echo '<a '.$class.' href="'.$CFG->wwwroot.'/blog/index.php?entryid='.$blog->id.'">';
             echo format_string($blog->subject);
             echo '</a>';
             echo ' - ';
@@ -126,7 +127,8 @@
         }
         echo '</ul>';
 
-        echo '<p class="moreblogs"><a href="'.blog_get_blogs_url(array('tag'=>$tag->id))->out().'">'.get_string('seeallblogs', 'tag', $tagname).'</a></p>';
+        $allblogsurl = new moodle_url($CFG->wwwroot.'/blog/index.php', array('tagid' => $tag->id));
+        echo '<p class="moreblogs"><a href="'.$allblogsurl->out().'">'.get_string('seeallblogs', 'tag', $tagname).'</a></p>';
 
         echo $OUTPUT->box_end();
     }
Index: user/tabs.php
=========================================================
--- user/tabs.php	(revision 1.82)
+++ user/tabs.php	Fri Oct 23 11:46:39 WST 2009
@@ -2,7 +2,6 @@
 /// This file to be included so we can assume config.php has already been included.
 /// We also assume that $user, $course, $currenttab have been set
 
-    require_once($CFG->dirroot.'/blog/lib.php');
     require_once($CFG->libdir . '/portfoliolib.php');
 
     if (!isset($filtertype)) {
@@ -29,27 +28,17 @@
     $toprow = array();
     $systemcontext   = get_context_instance(CONTEXT_SYSTEM);
 
-    /**************************************
-     * Site Level participation or Blogs  *
-     **************************************/
+    /****************************
+     * Site Level participation *
+     ****************************/
     if ($filtertype == 'site') {
 
         $site = get_site();
         echo $OUTPUT->heading(format_string($site->fullname));
 
-        if ($CFG->bloglevel >= 4) {
-            if (has_capability('moodle/site:viewparticipants', $systemcontext)) {
-                $toprow[] = new tabobject('participants', $CFG->wwwroot.'/user/index.php?id='.SITEID,
-                    get_string('participants'));
-            }
-
-            $toprow[] = new tabobject('blogs', blog_get_blogs_url(array())->out(),
-                get_string('blogs','blog'));
-        }
-
-    /**************************************
-     * Course Level participation or Blogs  *
-     **************************************/
+    /******************************
+     * Course Level participation *
+     ******************************/
     } else if ($filtertype == 'course' && $filterselect) {
 
         $course = $DB->get_record('course', array('id'=>$filterselect));
@@ -59,34 +48,22 @@
         $toprow[] = new tabobject('participants', $CFG->wwwroot.'/user/index.php?id='.$filterselect,
             get_string('participants'));
 
-        if ($CFG->bloglevel >= 3) {
-            $toprow[] = new tabobject('blogs', blog_get_blogs_url(array('course'=>$filterselect))->out(), get_string('blogs','blog'));
-        }
-
         if (!empty($CFG->enablenotes) and (has_capability('moodle/notes:manage', $coursecontext) || has_capability('moodle/notes:view', $coursecontext))) {
             $toprow[] = new tabobject('notes', $CFG->wwwroot.'/notes/index.php?filtertype=course&amp;filterselect=' . $filterselect, get_string('notes', 'notes'));
         }
 
-    /**************************************
-     * Group Level participation or Blogs  *
-     **************************************/
+    /*****************************
+     * Group Level participation *
+     *****************************/
     } else if ($filtertype == 'group' && $filterselect) {
 
         $group_name = groups_get_group_name($filterselect);
         echo $OUTPUT->heading($group_name);
 
-        if ($CFG->bloglevel >= 2) {
 
-            $toprow[] = new tabobject('participants', $CFG->wwwroot.'/user/index.php?id='.$course->id.'&amp;group='.$filterselect,
-                get_string('participants'));
-
-
-            $toprow[] = new tabobject('blogs', blog_get_blogs_url(array('group'=>$filterselect))->out(), get_string('blogs','blog'));
-        }
-
-    /**************************************
-     * User Level participation or Blogs  *
-     **************************************/
+    /****************************
+     * User Level participation *
+     ****************************/
     } else {
         if (isset($userid)) {
             $user = $DB->get_record('user', array('id'=>$userid));
@@ -129,19 +106,6 @@
 
         }
 
-    /// Personal blog entries tab
-        require_once($CFG->dirroot.'/blog/lib.php');
-        if ($CFG->bloglevel >= BLOG_USER_LEVEL and // blogs must be enabled
-            (has_capability('moodle/user:readuserblogs', $personalcontext) // can review posts (parents etc)
-            or has_capability('moodle/blog:manageentries', $systemcontext)     // entry manager can see all posts
-            or ($user->id == $USER->id and has_capability('moodle/blog:create', $systemcontext)) // viewing self
-            or (has_capability('moodle/blog:view', $systemcontext) or has_capability('moodle/blog:view', $coursecontext))
-            ) // able to read blogs in site or course context
-        ) { //end if
-
-            $toprow[] = new tabobject('blogs', blog_get_blogs_url(array('user'=>$user->id,'course'=>$course->id))->out(), get_string('blog', 'blog'));
-        }
-
         if (!empty($CFG->enablenotes) and (has_capability('moodle/notes:manage', $coursecontext) || has_capability('moodle/notes:view', $coursecontext))) {
             $toprow[] = new tabobject('notes', $CFG->wwwroot.'/notes/index.php?course='.$course->id . '&amp;user=' . $user->id, get_string('notes', 'notes'));
         }
